'in Ordnung, passend fr PING-PONG-Platine
'ping_osz1.bas
'23.12.2009
'Mustererzeugung mit 14 * 15 LEDs
'png_txt1.bas
$crystal = 8000000
$regfile = "m8def.dat"
$hwstack = 64                                               '128
$swstack = 64                                               '128
$framesize = 64                                             '128

Dim Leds(12) As Word
Dim X As Byte
Dim Y As Byte
Dim N As Word
Dim U As Byte
Dim T As Word



Declare Sub Standby
Declare Sub Test
Declare Sub Initialisierung

Declare Sub Led1(byval X As Byte , Byval Y As Byte)
Declare Sub Led0(byval X As Byte , Byval Y As Byte)



Initialisierung

Dim Xx As Single
Dim Yy As Single




Do
Leds(1) = 97                                                'Telefon "lutet"
Leds(2) = 114
Leds(3) = 916
Leds(4) = 592
Leds(5) = 567
Leds(6) = 560
Leds(7) = 560
Leds(8) = 567
Leds(9) = 624
Leds(10) = 916
Leds(11) = 114
Leds(12) = 97
Waitms 500
Leds(1) = 96                                                'Telefon "lutet nicht"
Leds(2) = 112
Leds(3) = 912
Leds(4) = 592
Leds(5) = 560
Leds(6) = 560
Leds(7) = 560
Leds(8) = 560
Leds(9) = 624
Leds(10) = 912
Leds(11) = 112
Leds(12) = 96
Waitms 500




Loop








Sub Led1(byval X As Byte , Byval Y As Byte)
 If X < 13 Then
  Select Case Y
    Case 1 : Leds(x).9 = 1
    Case 2 : Leds(x).8 = 1
    Case 3 : Leds(x).7 = 1
    Case 4 : Leds(x).6 = 1
    Case 5 : Leds(x).5 = 1
    Case 6 : Leds(x).4 = 1
    Case 7 : Leds(x).3 = 1
    Case 8 : Leds(x).2 = 1
    Case 9 : Leds(x).1 = 1
    Case 10 : Leds(x).0 = 1

   End Select
  End If
End Sub

Sub Led0(byval X As Byte , Byval Y As Byte)
  If X < 13 Then
  Select Case Y
    Case 1 : Leds(x).9 = 0
    Case 2 : Leds(x).8 = 0
    Case 3 : Leds(x).7 = 0
    Case 4 : Leds(x).6 = 0
    Case 5 : Leds(x).5 = 0
    Case 6 : Leds(x).4 = 0
    Case 7 : Leds(x).3 = 0
    Case 8 : Leds(x).2 = 0
    Case 9 : Leds(x).1 = 0
    Case 10 : Leds(x).0 = 0

   End Select
  End If
End Sub


'******************  Service-Unterprogramme *********************

Sub Initialisierung
  Config Portc = 15                                         'PORTC als AD-Eingang
  Config Portb = Output
  Config Portd = 255
  Config Timer2 = Timer , Prescale = 8
  On Ovf2 Tim2_isr
  Enable Timer2
  Enable Interrupts
  Start Timer2
  Config Adc = Single , Prescaler = 64 , Reference = Off
  Start Adc
  Config Int0 = Low Level                                   'Falling
  On Int0 Int_isr
End Sub


Sub Standby
  Stop Timer2
  Portc = 0
  Portd = 0
  Portb = 0
  Stop Adc
  Ddrd.2 = 0
  Portd.2 = 1
  Enable Int0
  Powerdown
  Ddrd.2 = 1
  Portd.2 = 0
  Start Adc
  Start Timer2
End Sub


Dim Vhelp As Word

Sub Test
      For X = 1 To 12
         Leds(x) = 1023
      Next X
      Waitms 1000
      For X = 1 To 12
         For Y = 1 To 12
            Leds(y) = 0
         Next Y
         Leds(x) = 1023
         Waitms 100
      Next X
      For Y = 1 To 10
         For X = 1 To 12
            Vhelp = Y - 1
            Vhelp = 2 ^ Vhelp
            Leds(x) = Vhelp
         Next X
         Waitms 100
      Next Y
      For X = 1 To 12
         Leds(x) = 0
      Next X
End Sub



Int_isr:
  Disable Int0
Return


'******************************* Interrupt - Display ****************************
Dim Vy As Byte
Dim Col As Byte
Dim Portdout As Byte
Dim Portcout As Byte


Tim2_isr:
 '800 s
'Timer2 = 56
Col = Col + 1
If Col = 13 Then Col = 1
Vy = Col + 0
Portd = 0
Portb = 0
Portc = 0
If Col = 1 Then Portb.4 = 0 Else Portb.4 = 1
Portb.3 = 1                                                 'cl
Portb.3 = 0
Portb.2 = 1                                                 'Str
Portb.2 = 0
Portdout = Low(leds(vy))
Portcout = Portdout And 15
Portdout = Portdout And 240
Portd = Portdout
Portc = Portcout
Portb = High(leds(vy))
'Waitms 500
Return

End